<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Tower Attack: CArcher Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Tower Attack
   </div>
   <div id="projectbrief">A simple console game</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classCArcher-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CArcher Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Archer 50% chance of extending range by half, 10 % chance of attacking twice.  
 <a href="classCArcher.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="attackers_8h_source.html">attackers.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for CArcher:</div>
<div class="dyncontent">
<div class="center"><img src="classCArcher__inherit__graph.png" border="0" usemap="#CArcher_inherit__map" alt="Inheritance graph"/></div>
<map name="CArcher_inherit__map" id="CArcher_inherit__map">
<area shape="rect" id="node2" href="classCAttacker.html" title="Attacker is one of the main game objects, it can attack and defend itself from other towers..." alt="" coords="5,80,87,107"/>
<area shape="rect" id="node3" href="classCEntity.html" title="Abstract class, used to store entities to map. " alt="" coords="13,5,79,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for CArcher:</div>
<div class="dyncontent">
<div class="center"><img src="classCArcher__coll__graph.png" border="0" usemap="#CArcher_coll__map" alt="Collaboration graph"/></div>
<map name="CArcher_coll__map" id="CArcher_coll__map">
<area shape="rect" id="node2" href="classCAttacker.html" title="Attacker is one of the main game objects, it can attack and defend itself from other towers..." alt="" coords="43,95,125,121"/>
<area shape="rect" id="node3" href="classCEntity.html" title="Abstract class, used to store entities to map. " alt="" coords="5,5,72,32"/>
<area shape="rect" id="node4" href="structTCoord.html" title="Coordinates, row and col. " alt="" coords="97,5,162,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a70b2c2e794a47fc717383a3bfa52d6b4"><td class="memItemLeft" align="right" valign="top"><a id="a70b2c2e794a47fc717383a3bfa52d6b4"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>CArcher</b> (char <a class="el" href="classCAttacker.html#a7b0fb16fc8285e01ee8f7cedc5343571">symbol</a>, const string &amp;name, int hp, int <a class="el" href="classCArcher.html#a0cf04733e2e416705e83cb963a486811">attack</a>, int range, int <a class="el" href="classCAttacker.html#a84a16391de74e89f0cbba0b134f1cd90">speed</a>, int parentID)</td></tr>
<tr class="separator:a70b2c2e794a47fc717383a3bfa52d6b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa13f5cbb0983ccf2e4d8cb27c16b905b"><td class="memItemLeft" align="right" valign="top"><a id="aa13f5cbb0983ccf2e4d8cb27c16b905b"></a>
<a class="el" href="classCAttacker.html">CAttacker</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCArcher.html#aa13f5cbb0983ccf2e4d8cb27c16b905b">clone</a> () const override</td></tr>
<tr class="memdesc:aa13f5cbb0983ccf2e4d8cb27c16b905b"><td class="mdescLeft">&#160;</td><td class="mdescRight">setter for health <br /></td></tr>
<tr class="separator:aa13f5cbb0983ccf2e4d8cb27c16b905b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acddd397be7733c5bd58ab9067b2d5823"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCArcher.html#acddd397be7733c5bd58ab9067b2d5823">hasInRange</a> (const <a class="el" href="structTCoord.html">TCoord</a> &amp;src) const override</td></tr>
<tr class="memdesc:acddd397be7733c5bd58ab9067b2d5823"><td class="mdescLeft">&#160;</td><td class="mdescRight">clones this object  <a href="#acddd397be7733c5bd58ab9067b2d5823">More...</a><br /></td></tr>
<tr class="separator:acddd397be7733c5bd58ab9067b2d5823"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0cf04733e2e416705e83cb963a486811"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCArcher.html#a0cf04733e2e416705e83cb963a486811">attack</a> (<a class="el" href="classCTower.html">CTower</a> &amp;dst) override</td></tr>
<tr class="memdesc:a0cf04733e2e416705e83cb963a486811"><td class="mdescLeft">&#160;</td><td class="mdescRight">Archers's special ability sometimes archer can attack twice.  <a href="#a0cf04733e2e416705e83cb963a486811">More...</a><br /></td></tr>
<tr class="separator:a0cf04733e2e416705e83cb963a486811"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75d02fd8d17cd797de726d6175331bbe"><td class="memItemLeft" align="right" valign="top"><a id="a75d02fd8d17cd797de726d6175331bbe"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCArcher.html#a75d02fd8d17cd797de726d6175331bbe">printDetails</a> (ostream &amp;os) const override</td></tr>
<tr class="memdesc:a75d02fd8d17cd797de726d6175331bbe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Print archer's details. <br /></td></tr>
<tr class="separator:a75d02fd8d17cd797de726d6175331bbe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8955f80c34fff42893b74b7260272ebf"><td class="memItemLeft" align="right" valign="top"><a id="a8955f80c34fff42893b74b7260272ebf"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCArcher.html#a8955f80c34fff42893b74b7260272ebf">print</a> (ostream &amp;os) const override</td></tr>
<tr class="memdesc:a8955f80c34fff42893b74b7260272ebf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Print archer's symbol. <br /></td></tr>
<tr class="separator:a8955f80c34fff42893b74b7260272ebf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classCAttacker"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classCAttacker')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classCAttacker.html">CAttacker</a></td></tr>
<tr class="memitem:a5173f06a05a13aaedbc922dfd5379ba8 inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a5173f06a05a13aaedbc922dfd5379ba8">CAttacker</a> (char <a class="el" href="classCAttacker.html#a7b0fb16fc8285e01ee8f7cedc5343571">symbol</a>, const string &amp;name, int hp, int <a class="el" href="classCAttacker.html#ab80d734314eeb349e86931d2d50289d9">attack</a>, int range, int <a class="el" href="classCAttacker.html#a84a16391de74e89f0cbba0b134f1cd90">speed</a>, int parentID)</td></tr>
<tr class="memdesc:a5173f06a05a13aaedbc922dfd5379ba8 inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">Attacker constructor, sets member variables.  <a href="classCAttacker.html#a5173f06a05a13aaedbc922dfd5379ba8">More...</a><br /></td></tr>
<tr class="separator:a5173f06a05a13aaedbc922dfd5379ba8 inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a317e10be6678348685f76eca1aa2e67f inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a317e10be6678348685f76eca1aa2e67f">setPath</a> (const list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt; &amp;path)</td></tr>
<tr class="memdesc:a317e10be6678348685f76eca1aa2e67f inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets path to attacker.  <a href="classCAttacker.html#a317e10be6678348685f76eca1aa2e67f">More...</a><br /></td></tr>
<tr class="separator:a317e10be6678348685f76eca1aa2e67f inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad169c0c3b122289339d5c9c11f6dd2f1 inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="ad169c0c3b122289339d5c9c11f6dd2f1"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>setEntrance</b> (int entranceIdx)</td></tr>
<tr class="separator:ad169c0c3b122289339d5c9c11f6dd2f1 inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac99d568c2cdce5d0c35b42bf16d9302f inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#ac99d568c2cdce5d0c35b42bf16d9302f">move</a> ()</td></tr>
<tr class="memdesc:ac99d568c2cdce5d0c35b42bf16d9302f inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">sets entrance ID  <a href="classCAttacker.html#ac99d568c2cdce5d0c35b42bf16d9302f">More...</a><br /></td></tr>
<tr class="separator:ac99d568c2cdce5d0c35b42bf16d9302f inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc8bae44906274f3340bc91858367ead inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#abc8bae44906274f3340bc91858367ead">save</a> (ofstream &amp;ofs) const</td></tr>
<tr class="memdesc:abc8bae44906274f3340bc91858367ead inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">Save attacker to stream given by parameter.  <a href="classCAttacker.html#abc8bae44906274f3340bc91858367ead">More...</a><br /></td></tr>
<tr class="separator:abc8bae44906274f3340bc91858367ead inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3f22ead3302344cc23defe93994e6db inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structTCoord.html">TCoord</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#ad3f22ead3302344cc23defe93994e6db">nextMove</a> (int maxSpeed)</td></tr>
<tr class="memdesc:ad3f22ead3302344cc23defe93994e6db inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the next position where attacker is heading, if it has moved m_speed times and the map speed is faster, it doesn't move and returns current position.  <a href="classCAttacker.html#ad3f22ead3302344cc23defe93994e6db">More...</a><br /></td></tr>
<tr class="separator:ad3f22ead3302344cc23defe93994e6db inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acc2378e8d89ff78fc775492a7b2daa86 inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="acc2378e8d89ff78fc775492a7b2daa86"></a>
<a class="el" href="structTCoord.html">TCoord</a>&#160;</td><td class="memItemRight" valign="bottom"><b>position</b> () const</td></tr>
<tr class="separator:acc2378e8d89ff78fc775492a7b2daa86 inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b0fb16fc8285e01ee8f7cedc5343571 inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="a7b0fb16fc8285e01ee8f7cedc5343571"></a>
char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a7b0fb16fc8285e01ee8f7cedc5343571">symbol</a> () const</td></tr>
<tr class="memdesc:a7b0fb16fc8285e01ee8f7cedc5343571 inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">setter for position of the attacker <br /></td></tr>
<tr class="separator:a7b0fb16fc8285e01ee8f7cedc5343571 inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a84a16391de74e89f0cbba0b134f1cd90 inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="a84a16391de74e89f0cbba0b134f1cd90"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a84a16391de74e89f0cbba0b134f1cd90">speed</a> () const</td></tr>
<tr class="memdesc:a84a16391de74e89f0cbba0b134f1cd90 inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for symbol of the attacker <br /></td></tr>
<tr class="separator:a84a16391de74e89f0cbba0b134f1cd90 inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d1bd8010d5f5628dd4a0bd8a973a3bb inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="a5d1bd8010d5f5628dd4a0bd8a973a3bb"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a5d1bd8010d5f5628dd4a0bd8a973a3bb">resetSpeedCnt</a> ()</td></tr>
<tr class="memdesc:a5d1bd8010d5f5628dd4a0bd8a973a3bb inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for speed of the attacker <br /></td></tr>
<tr class="separator:a5d1bd8010d5f5628dd4a0bd8a973a3bb inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a82ee1f8ecbb8754f223c2eba3cf799a3 inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a82ee1f8ecbb8754f223c2eba3cf799a3">defend</a> (<a class="el" href="classCTower.html">CTower</a> &amp;src)</td></tr>
<tr class="memdesc:a82ee1f8ecbb8754f223c2eba3cf799a3 inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default defend method of the attackers.  <a href="classCAttacker.html#a82ee1f8ecbb8754f223c2eba3cf799a3">More...</a><br /></td></tr>
<tr class="separator:a82ee1f8ecbb8754f223c2eba3cf799a3 inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa0b6e1fcbee3cb390d252d5f8c4474f7 inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="aa0b6e1fcbee3cb390d252d5f8c4474f7"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#aa0b6e1fcbee3cb390d252d5f8c4474f7">defend</a> (<a class="el" href="classCMedic.html">CMedic</a> &amp;src)</td></tr>
<tr class="memdesc:aa0b6e1fcbee3cb390d252d5f8c4474f7 inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default defend method against medic. <br /></td></tr>
<tr class="separator:aa0b6e1fcbee3cb390d252d5f8c4474f7 inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27352022dbe260beae06e7cd535062dc inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="a27352022dbe260beae06e7cd535062dc"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a27352022dbe260beae06e7cd535062dc">defend</a> (<a class="el" href="classCArtillery.html">CArtillery</a> &amp;src)</td></tr>
<tr class="memdesc:a27352022dbe260beae06e7cd535062dc inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default defend method against artillery. <br /></td></tr>
<tr class="separator:a27352022dbe260beae06e7cd535062dc inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6151f85fde51772b9034bee6f3cf0b37 inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="a6151f85fde51772b9034bee6f3cf0b37"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>getAttack</b> () const</td></tr>
<tr class="separator:a6151f85fde51772b9034bee6f3cf0b37 inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2fda02cade366510afb500d22143b558 inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="a2fda02cade366510afb500d22143b558"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a2fda02cade366510afb500d22143b558">getHp</a> () const</td></tr>
<tr class="memdesc:a2fda02cade366510afb500d22143b558 inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for attack strength <br /></td></tr>
<tr class="separator:a2fda02cade366510afb500d22143b558 inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab8640dff4a1129c25c59af1f217995fb inherit pub_methods_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="ab8640dff4a1129c25c59af1f217995fb"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#ab8640dff4a1129c25c59af1f217995fb">setHp</a> (int hp)</td></tr>
<tr class="memdesc:ab8640dff4a1129c25c59af1f217995fb inherit pub_methods_classCAttacker"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for health <br /></td></tr>
<tr class="separator:ab8640dff4a1129c25c59af1f217995fb inherit pub_methods_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classCEntity"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classCEntity')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classCEntity.html">CEntity</a></td></tr>
<tr class="memitem:a9ab2d129368e2d3acfec883129439e1c inherit pub_methods_classCEntity"><td class="memItemLeft" align="right" valign="top"><a id="a9ab2d129368e2d3acfec883129439e1c"></a>
virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCEntity.html#a9ab2d129368e2d3acfec883129439e1c">discover</a> () const</td></tr>
<tr class="memdesc:a9ab2d129368e2d3acfec883129439e1c inherit pub_methods_classCEntity"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the field is discoverable ( if it's either free space or path ) <br /></td></tr>
<tr class="separator:a9ab2d129368e2d3acfec883129439e1c inherit pub_methods_classCEntity"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5bedcc5d44f5b4a65d8abd8bc7766588 inherit pub_methods_classCEntity"><td class="memItemLeft" align="right" valign="top"><a id="a5bedcc5d44f5b4a65d8abd8bc7766588"></a>
virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCEntity.html#a5bedcc5d44f5b4a65d8abd8bc7766588">isPath</a> () const</td></tr>
<tr class="memdesc:a5bedcc5d44f5b4a65d8abd8bc7766588 inherit pub_methods_classCEntity"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints the object ( it's symbol ) <br /></td></tr>
<tr class="separator:a5bedcc5d44f5b4a65d8abd8bc7766588 inherit pub_methods_classCEntity"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a833f1423fd7e0f2096517b100c44db72 inherit pub_methods_classCEntity"><td class="memItemLeft" align="right" valign="top"><a id="a833f1423fd7e0f2096517b100c44db72"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCEntity.html#a833f1423fd7e0f2096517b100c44db72">~CEntity</a> ()=default</td></tr>
<tr class="memdesc:a833f1423fd7e0f2096517b100c44db72 inherit pub_methods_classCEntity"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the field is path or not. <br /></td></tr>
<tr class="separator:a833f1423fd7e0f2096517b100c44db72 inherit pub_methods_classCEntity"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a0bf581ac770b7cc02d842b23fc11f8f2"><td class="memItemLeft" align="right" valign="top"><a id="a0bf581ac770b7cc02d842b23fc11f8f2"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_extendedDistanceChance</b></td></tr>
<tr class="separator:a0bf581ac770b7cc02d842b23fc11f8f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afded122eae8c7fd14340b652def07db7"><td class="memItemLeft" align="right" valign="top"><a id="afded122eae8c7fd14340b652def07db7"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_twiceChance</b></td></tr>
<tr class="separator:afded122eae8c7fd14340b652def07db7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classCAttacker"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classCAttacker')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classCAttacker.html">CAttacker</a></td></tr>
<tr class="memitem:afa3a9b9cd0d07c81517c19297d1a82d8 inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="afa3a9b9cd0d07c81517c19297d1a82d8"></a>
<a class="el" href="structTCoord.html">TCoord</a>&#160;</td><td class="memItemRight" valign="bottom"><b>m_pos</b></td></tr>
<tr class="separator:afa3a9b9cd0d07c81517c19297d1a82d8 inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa48a189c978311cf04fa6f99c98c8214 inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="aa48a189c978311cf04fa6f99c98c8214"></a>
list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>m_pathToEnd</b></td></tr>
<tr class="separator:aa48a189c978311cf04fa6f99c98c8214 inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba8a93ffda4d7e3232159abc7cbf1c6a inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="aba8a93ffda4d7e3232159abc7cbf1c6a"></a>
list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt;::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><b>m_pathIt</b></td></tr>
<tr class="separator:aba8a93ffda4d7e3232159abc7cbf1c6a inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8df1fa17340f9992421dabf58c532c9 inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="af8df1fa17340f9992421dabf58c532c9"></a>
char&#160;</td><td class="memItemRight" valign="bottom"><b>m_symbol</b></td></tr>
<tr class="separator:af8df1fa17340f9992421dabf58c532c9 inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0cdbce1ccb67d6bb33fa2a365492ffd inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="ad0cdbce1ccb67d6bb33fa2a365492ffd"></a>
string&#160;</td><td class="memItemRight" valign="bottom"><b>m_name</b></td></tr>
<tr class="separator:ad0cdbce1ccb67d6bb33fa2a365492ffd inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad53bbe35233105ba5770fc7962beaede inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="ad53bbe35233105ba5770fc7962beaede"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_hp</b></td></tr>
<tr class="separator:ad53bbe35233105ba5770fc7962beaede inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a94e22b914a91e8d78a81abf681499289 inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="a94e22b914a91e8d78a81abf681499289"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_attack</b></td></tr>
<tr class="separator:a94e22b914a91e8d78a81abf681499289 inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8cb8c0ee70d9ce5770a8206e6b004b47 inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="a8cb8c0ee70d9ce5770a8206e6b004b47"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_range</b></td></tr>
<tr class="separator:a8cb8c0ee70d9ce5770a8206e6b004b47 inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af26e963ac52a623ae9c3346363e9fe7c inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="af26e963ac52a623ae9c3346363e9fe7c"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_speed</b></td></tr>
<tr class="separator:af26e963ac52a623ae9c3346363e9fe7c inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6b63d8b2559885bc92b99de25f4bf22 inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="af6b63d8b2559885bc92b99de25f4bf22"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_speedCnt</b></td></tr>
<tr class="separator:af6b63d8b2559885bc92b99de25f4bf22 inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad01a568a6fc0e581e0c8aedbb2f98f5d inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="ad01a568a6fc0e581e0c8aedbb2f98f5d"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_parentID</b></td></tr>
<tr class="separator:ad01a568a6fc0e581e0c8aedbb2f98f5d inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cfa0704fb19a72ea01e3f6bce1ecdd5 inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="a1cfa0704fb19a72ea01e3f6bce1ecdd5"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_steps</b></td></tr>
<tr class="separator:a1cfa0704fb19a72ea01e3f6bce1ecdd5 inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac72ed558981fd8be20021a00fe0b1ea3 inherit pro_attribs_classCAttacker"><td class="memItemLeft" align="right" valign="top"><a id="ac72ed558981fd8be20021a00fe0b1ea3"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_entranceID</b></td></tr>
<tr class="separator:ac72ed558981fd8be20021a00fe0b1ea3 inherit pro_attribs_classCAttacker"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Archer 50% chance of extending range by half, 10 % chance of attacking twice. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a0cf04733e2e416705e83cb963a486811"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0cf04733e2e416705e83cb963a486811">&#9670;&nbsp;</a></span>attack()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CArcher::attack </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classCTower.html">CTower</a> &amp;&#160;</td>
          <td class="paramname"><em>dst</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Archers's special ability sometimes archer can attack twice. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dst</td><td>tower attacking </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="classCAttacker.html#ab80d734314eeb349e86931d2d50289d9">CAttacker</a>.</p>

</div>
</div>
<a id="acddd397be7733c5bd58ab9067b2d5823"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acddd397be7733c5bd58ab9067b2d5823">&#9670;&nbsp;</a></span>hasInRange()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CArcher::hasInRange </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structTCoord.html">TCoord</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>clones this object </p>
<p>Archer's special ability sometimes, archer can extend it's range.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>coordinates to compare </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>if the coordinates are in archer's reach </dd></dl>

<p>Reimplemented from <a class="el" href="classCAttacker.html#ab80eeb5cfe0dc7ac9979a35a60cfb7c3">CAttacker</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="attackers_8h_source.html">attackers.h</a></li>
<li>attackers.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
